<?php
class ModelExtensionPaymentAffirm extends Model {
  public function formatPrice($usd){ return number_format((float)$usd,2,'.','')*100; }
  public function fetchCouponDetails($code) { $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "marketing WHERE code = '" . $this->db->escape($code) . "'");	return $query->row; }
  public function fetchPromoDetails($product_id) {
    $adc = array(); $temp = array(); $categories = array(); $category = array(); $product_info = array(); 
    $categories = $this->model_catalog_product->getCategories($product_id);
    foreach($categories as $c){
      $category = $this->model_catalog_category->getCategory($c['category_id']);
      $product_info = $this->model_catalog_product->getProduct($product_id);
    	if ($category) {
        if($c['product_id'] == $product_id){
          $adc[] = array(
            'sku' => $product_info['sku'],
            'id'        => $product_id,
            'category' => array(
      			'category_id' => $c['category_id'],
      			'name'        => $category['name'] 
      	));
      	}
      }
    }
    foreach ($adc as $key => $value) {
      if (is_array($value)){ $temp = array_merge($temp, $value); } 
      else { $temp[$key] = $value; }
    }
    $data['adcx'] = array_merge($temp);
    return $data;
  }
  
  public function getChargeId($order_id) {
		$q = $this->db->query("SELECT * FROM `" . DB_PREFIX . "affirm_order` WHERE `order_id` = '" . (int)$order_id . "' LIMIT 1");
		if ($q->num_rows) {
			$order = $q->row;
			$order['charge_id'] = $q->row['charge_id']; 
			$order['order_id'] = $q->row['order_id'];
			return $order;
		} else {
			return false;
		}
	}
	public function getMethod($address, $total) {
		$this->load->language('extension/payment/affirm');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('payment_affirm_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		$method_data = array();
    
    $ala = $this->language->get("text_affirm_class_affirm_as_low_as");
    $sm = $this->language->get("text_affirm_class_affirm_site_modal"); 
    $pm = $this->language->get("text_affirm_class_affirm_product_modal");
    $pat = $this->language->get("text_affirm_page_type_payment"); 
    $hat = $this->language->get("text_affirm_page_type_homepage"); 
    $lat = $this->language->get("text_affirm_page_type_landing");
    $sat = $this->language->get("text_affirm_page_type_search");
    $bat = $this->language->get("text_affirm_page_type_banner");
    $cat = $this->language->get("text_affirm_page_type_cart"); 
    $caat = $this->language->get("text_affirm_page_type_category");
    $prat = $this->language->get("text_affirm_page_type_product");
    $dpid = $this->config->get('payment_affirm_data_promo_id');
    
    $asjs = 'https://cdn1-sandbox.affirm.com/js/v2/affirm.js';
    $ajs = 'https://cdn1.affirm.com/js/v2/affirm.js';
    
    $as = $this->config->get('payment_affirm_sandbox');
    $apk = $this->config->get('payment_affirm_public_key');
    $apma = false;//$this->config->get('payment_affirm_payment_method_ala');
    
    $affirm_link = '';
    if($apma == true){
      if($dpid == ""){ $link = '<p class="'.$ala.'" data-page-type="'.$pat.'" data-amount="' . $this->formatPrice($total) . '"></p>'; }
      else{ $link = '<p class="'.$ala.'" data-promo-id="'.$dpid.'" data-page-type="'.$pat.'" data-amount="'. $this->formatPrice($total) .'"></p>'; }
      $acs = '<script>var _affirm_config = {public_api_key : "'.$apk.'", script : "'.$asjs.'"};</script>';
      $affirmjs = '<script>(function(l,g,m,e,a,f,b){var d,c=l[m]||{},h=document.createElement(f),n=document.getElementsByTagName(f)[0],k=function(a,b,c){return function(){a[b]._.push([c,arguments])}};c[e]=k(c,e,"set");d=c[e];c[a]={};c[a]._=[];d._=[];c[a][b]=k(c,a,b);a=0;for(b="set add save post open empty reset on off trigger ready setProduct".split(" ");a<b.length;a++)d[b[a]]=k(c,e,b[a]);a=0;for(b=["get","token","url","items"];a<b.length;a++)d[b[a]]=function(){};h.async=!0;h.src=g[f];n.parentNode.insertBefore(h,n);delete g[f];d(g);l[m]=c})(window,_affirm_config,"affirm","checkout","ui","script","ready");</script>';  
      $affirm_link = $link . $acs . $affirmjs;
    }
    else
    {
      $affirm_logo = "<img src='https://cdn-assets.affirm.com/images/black_logo-transparent_bg.png' width='119' height='36' alt='Affirm' />";
      $affirm_logo_message = "Monthly Payments";
      $affirm_terms = "<p style='padding-top;2em;'>You will be redirected to Affirm to securely complete your purchase. Just fill out a few pieces of basic information and get a real-time decision. Checking your eligibility won't affect your credit score.</p>";
      $affirm_link = $affirm_logo . ' ' . $affirm_logo_message . '<br />' . $affirm_terms;
    }
    
    if ($this->config->get('payment_affirm_total_min') > $total || $this->config->get('payment_affirm_total_max') <  $total ) {
			$status = false;
		} elseif (!$this->config->get('payment_affirm_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

		if ($status) {
			$method_data = array(
				'code'       => 'affirm',
        'title' => "Affirm",
				'terms'      => $affirm_link, 
				'total'      => $this->formatPrice($total), 
				'sort_order' => $this->config->get('payment_affirm_sort_order')
			);
		}
    
    
		return $method_data;
	}
  
  public function createCharge($checkout_token, $order_id) {
    $sandbox = $this->config->get('payment_affirm_sandbox');
    $data = array('order_id' => $order_id, 'checkout_token' => $checkout_token);
    if($sandbox){$response = $this->PostAuthorizationAffirm(true, $data);}
    else{$response = $this->PostAuthorizationAffirm(false, $data);}
    $chargeId = $response['id'];
		$this->db->query("INSERT INTO `" . DB_PREFIX . "affirm_order` SET `charge_id` = '" . $chargeId . "',`order_id` = '" . $this->db->escape($order_id) . "',`amount` = '" . $this->db->escape($response['amount']) . "'");
	  $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET `type` = 'capture', `stamp` = '". time() . "' where `charge_id` = '".$chargeId."'");
    
    return $chargeId;
  }
  
  public function captureCharge($order_id, $shippingCarrier, $trackingNumber = null) {
    $sandbox = $this->config->get('payment_affirm_sandbox');
    $data = array('order_id' => $order_id, 'shipping_carrier' => $shippingCarrier, 'shipping_confirmation' => $trackingNumber);
    $charge = $this->getChargeId($order_id);
    $chargeId = $charge['charge_id'];
    if($sandbox){$response = $this->PostCaptureAffirm(true, $data, $chargeId);}
    else{$response = $this->PostCaptureAffirm(false, $data, $chargeId);} 
		$this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET `charge_id` = '" . $chargeId . "', `type` = 'capture', `created` = '". $response['created'] ."', `shipping_carrier` = '" . $this->db->escape($shippingCarrier) . "',`shipping_confirmation` = '" . $this->db->escape($trackingNumber) . "', `fee` = '".$this->db->escape($response['fee'])."', `transaction_id` = '".$this->db->escape($response['transaction_id'])."', `amount` = '".$this->db->escape($response['amount'])."' WHERE `charge_id` = '" . $chargeId . "'");
    //$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "', `type` = 'capture', `created` = '". $response['created'] ."', `message` = 'Order captured: ''" . $this->db->escape($chargeId) ."'");
    return $chargeId;
  }
  
  public function readCharge($chargeId) {
    $sandbox = $this->config->get('payment_affirm_sandbox');
    if($sandbox){$response = $this->GetReadAffirm(true, $chargeId);}
    else{$response = $this->GetReadAffirm(false, $chargeId);}
    $this->db->query("UPDATE `" . DB_PREFIX . "affirm_order` SET `status` = '" . $this->db->escape($response['status']) . "', `created` = '" . $this->db->escape($response['created']) . "', `currency` = '" . $this->db->escape($response['currency']) . "' , `amount` = '" . $this->db->escape($response['amount']) . "', `auth_hold` = '" . $this->db->escape($response['auth_hold']) . "', `payable` = '" . $this->db->escape($response['payable']) . "', `void` = '" . $this->db->escape($response['void']) . "', `expires` = '" . $this->db->escape($response['expires']) . "', `order_id` = '" . $this->db->escape($response['order_id']) . "' WHERE `charge_id` = '" . $chargeId . "'");
		//$this->db->query("INSERT `" . DB_PREFIX . "affirm_event` SET `affirm_id` = '" . $chargeId . "',`type` = 'void', `message` = 'Order '" . $this->db->escape($response['order_id']) . "' information sync at : '" . $this->db->escape($response['created']) . "'");
  }
  
  private function PostCaptureAffirm($sandbox,$data,$chargeId) {
    $request = json_encode($data);
    $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
    $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
    if($sandbox){ $url = $sandbox_auth_url; }
    else{ $url = $live_auth_url; }
    $public_key = $this->config->get('payment_affirm_public_key'); 
    $private_key = $this->config->get('payment_affirm_private_key');
    if($public_key != null){
    $keypair = $public_key.':'.$private_key;
    $capturePayment = $url.''.$chargeId.'/capture';
    $headers[] = 'Accept-Charset: utf-8';
    $headers[] = 'Content-Type: application/json';
    $this->lastHeaders = $headers;
    $curl = curl_init($capturePayment); 
    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($curl, CURLOPT_URL, $capturePayment);
    curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
    curl_setopt($curl, CURLOPT_USERPWD, $keypair); 
    curl_setopt($curl, CURLOPT_HEADER, false); 
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
    $response = curl_exec($curl);
    $response = json_decode($response, true);
    curl_close($curl);
    return $response;
    }
    else{
      throw new Exception("There was an issue authorizing your Affirm loan. Please check out again or use a different payment method.");
      return "There was an issue authorizing your Affirm loan. Please check out again or use a different payment method.";
    }
  }
  
  private function GetReadAffirm($sandbox,$chargeId) {
    $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
    $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
    if($sandbox){ $url = $sandbox_auth_url; }
    else{ $url = $live_auth_url; }
    $public_key = $this->config->get('payment_affirm_public_key'); 
    $private_key = $this->config->get('payment_affirm_private_key');
    if($public_key != null){
    $keypair = $public_key.':'.$private_key;
    $readCharge = $url.''.$chargeId;
    $headers[] = 'Accept-Charset: utf-8';
    $headers[] = 'Content-Type: application/json';
    $this->lastHeaders = $headers;
    $curl = curl_init($readCharge); 
    curl_setopt($curl, CURLOPT_URL, $readCharge);
    curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
    curl_setopt($curl, CURLOPT_USERPWD, $keypair); 
    curl_setopt($curl, CURLOPT_HEADER, false); 
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    $response = curl_exec($curl);
    $response = json_decode($response, true);
    curl_close($curl);
    return $response;
    }
    else{
      throw new Exception("There was an issue updating the Affirm loan. Please try again or use your merchant dashboard on Affirm.");
      return "There was an issue updating the Affirm loan. Please try again or use your merchant dashboard on Affirm.";
    }
  }
  
  private function PostAuthorizationAffirm($sandbox,$data) {
    $request = json_encode($data);
    $live_auth_url = 'https://api.affirm.com/api/v2/charges/';
    $sandbox_auth_url = 'https://sandbox.affirm.com/api/v2/charges/';
    if($sandbox){ $url = $sandbox_auth_url; }
    else{ $url = $live_auth_url; }
    $public_key = $this->config->get('payment_affirm_public_key'); 
    $private_key = $this->config->get('payment_affirm_private_key');
    if($public_key != null){
    $keypair = $public_key.':'.$private_key;
    $capturePayment = $url;
    $headers[] = 'Accept-Charset: utf-8';
    $headers[] = 'Content-Type: application/json';
    $this->lastHeaders = $headers;
    $curl = curl_init($capturePayment); 
    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($curl, CURLOPT_URL, $capturePayment);
    curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST");
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); 
    curl_setopt($curl, CURLOPT_USERPWD, $keypair); 
    curl_setopt($curl, CURLOPT_HEADER, false); 
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $request);
    $response = curl_exec($curl);
    $response = json_decode($response, true);
    curl_close($curl);
    return $response;
    }
    else{
      throw new Exception("There was an issue authorizing your Affirm loan. Please check out again or use a different payment method.");
      return "There was an issue authorizing your Affirm loan. Please check out again or use a different payment method.";
    }
  }
}